X-Git-Url: https://git.xinqibao.xyz/dmenu.git/blobdiff_plain/8b633bf17de71ffec76b2413c23c01bb705c36b8..4776d6dc6148498a1eab11dd3a15c03736f15d42:/dmenu_path?ds=sidebyside

diff --git a/dmenu_path b/dmenu_path
index e725ede..1b1b241 100755
--- a/dmenu_path
+++ b/dmenu_path
@@ -1,32 +1,9 @@
 #!/bin/sh
 CACHE=$HOME/.dmenu_cache
-UPTODATE=1
 IFS=:
 
-uptodate() { [ $UPTODATE -eq 1 ]; }
-
-if test ! -f $CACHE 
-then
-	UPTODATE=0
-fi
-
-if uptodate
-then
-	for dir in $PATH
-	do
-		test $dir -nt $CACHE && { UPTODATE=0; break; }
-	done
-fi
-
-if ! uptodate
-then
-	for dir in $PATH
-	do
-		for file in "$dir"/*
-		do
-			test -x "$file" && echo "${file##*/}"
-		done
-	done | sort | uniq > $CACHE
+if ! test -f "$CACHE" || find $PATH -type d -newer "$CACHE" | grep -q .; then
+	find $PATH ! -type d \( -perm -1 -o -perm -10 -o -perm -100 \) | sed 's/.*\///' | sort -u > "$CACHE"
 fi
 
-cat $CACHE
+cat "$CACHE"